# 通用网页视频下载油猴脚本

## 特性
- 使用JS-Hook技术基于MediaSource原理捕获解密后的原始视频流,通杀几乎所有网页视频防下载保护方案
- 下载后的文件为原始数据,无视视频中的水印
- 支持直播流

## 已测试场景
- bilibili所有视频含付费保护视频
- bilibili直播
- 虎牙直播
- 慕课网
- 腾讯课堂
- 极客时间
- P站 -_-;

## 用法
- 使用油猴插件导入脚本,修改作用域
- 脚本生效后视频完成加载会自动完成下载
- 下载后的文件需要使用FFmpeg完成音视频合并

## 参数
```javascript
//自动快进
evanEnv.enableAutoForward = true
//完成后自动下载
evanEnv.enableAutoDownload = true
```

## FFmpeg合并示例
```shell
ffmpeg -i mediasource_0_0_0.mp4 -i mediasource_0_1_0.mp4 -c copy -bsf:a aac_adtstoasc out.mp4
```

## 大文件分段需要先文件合并
```
copy /b mediasource_0_0_*.mp4 out.mp4
```

## 常见问题
- 合并后声音播放不正常:由于部分网站使用了HE-AAC v2(AAC+SBR+PS)作为音频编码,大部分播放器还不支持此音频流格式,故声音不正常,使用Windows自带的视频播放器播放正常


## 特别说明
- 仅限内部交流使用,请勿用于非法用途